#!/usr/bin/python
##### Uklon na krozni odprtini - S53MV 12.03.2018 #####

import math,cmath	#uporabljene funkcije

ka=0.0001	#korak risanja
amax=1		#najvecji polmer odprtine [m]
dt=1		#razdalja do oddajnika [m]
dr=1		#razdalja do sprejemnika [m]
k=2*math.pi/0.1	#valovno stevilo [rd/m]

x=[]		#polja za risanje grafa
y=[]
yr=[]
yi=[]
z=[]
zr=[]
zi=[]

def priblizno(a,k,dt,dr):	#priblizek uklona krozne odprtine
	return 1-cmath.exp(complex(0,-k*(dt+dr)/(2*dt*dr)*a*a))

def tocno(a,k,dt,dr):	#tocna integracija uklona krozne odprtine
	dt2=dt*dt
	dr2=dr*dr
	s=0
	kr=0.0001	#korak integracije
	r=kr/2
	while r<a:	#zanka sestevanja
		rt=math.sqrt(dt2+r*r)
		rr=math.sqrt(dr2+r*r)
		ct=dt/rt
		cr=dr/rr
		s=s+(ct+cr)*r*cmath.exp(complex(0,-k*(rt+rr)))/(rt*rr)
		r=r+kr
	return complex(0,1)*k*(dr+dt)*cmath.exp(complex(0,k*(dt+dr)))*s*kr/2

a=ka/2		#zacetni a
while a<amax:
	x=x+[a]			#dodaj tocko v risbo
	s=priblizno(a,k,dt,dr)	#priblizek uklona
	y=y+[abs(s)]
	yr=yr+[s.real]
	yi=yi+[s.imag]
	s=tocno(a,k,dt,dr)	#tocen izracun
	z=z+[abs(s)]
	zr=zr+[s.real]
	zi=zi+[s.imag]
	a=a+ka			#povecaj t za korak

import matplotlib.pyplot as plt		#risanje grafa funkcije
fig=plt.figure()
plt.plot(x,y,'r-')
plt.plot(x,z,'b-')
plt.axis([0,a,0,2.2])
plt.title('Amplituda uklona na okrogli odprtini')
plt.yticks([0,1,2],['0',r'$E_\infty$',r'2$E_\infty$'])
plt.xlabel('Polmer odprtine $a$ [m]')
plt.ylabel('Amplituda uklonjenega polja |$E$|')
plt.grid(True)
fig.savefig('uklon-k.svg', transparent=True)

fig=plt.figure()
plt.plot([-0.2,2.2],[0,0],'k-')
plt.plot([0,0],[-1.2,1.2],'k-')
plt.plot(yr,yi,'r-')
plt.plot(zr,zi,'b-')
plt.axis([-0.2,2.2,-1.2,1.2])
plt.title('Kompleksna vsota uklona na okrogli odprtini')
plt.xticks([0,1,2],['0',r'$E_\infty$',r'2$E_\infty$'])
plt.yticks([-1,0,1],[r'$-jE_\infty$','0',r'$jE_\infty$'])
plt.xlabel('Sofazna komponenta polja $E$')
plt.ylabel('Kvadraturna komponenta polja $E$')
plt.axes().set_aspect('equal')
plt.grid(True)
fig.savefig('uklon-p.svg', transparent=True)
plt.show()

#konec programa

